<?php

/**
* Gavick VM Products Scroller
* @package Joomla!
* @Copyright (C) 2007 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0 $
**/

/**
	access restriction
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
	getting global variables
**/

global $mosConfig_absolute_path, $sess;
require_once( $mosConfig_absolute_path.'/components/com_virtuemart/virtuemart_parser.php' );

/**
	getting PA variables
**/

$module_width = $params->get('module_width',600); // 
$block_height = $params->get('block_height',200); // 
$select_type = $params->get('select_type',1);
$categories = $params->get('categories',null); // 
$max_amount = $params->get('max_amount',10); // 
$visible_amount = $params->get('visible_amount',3); //
$show_price = (bool)$params->get('show_price',1); // 
$show_cart = (bool)$params->get('show_cart',1); // 
$useMoo = $params->get('useMoo',1); // 
$useScript = $params->get('useScript',1); // 

// spaces beetween blocks
$space = 8;

require_once ( CLASSPATH. 'ps_product.php');
$ps_product = new ps_product;
$db = new ps_DB;


if($select_type == 1){
	if ($categories) {
		$cat_ids = explode(",",$categories);
		$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE (#__{vm}_product.product_parent_id='' OR #__{vm}_product.product_parent_id='0') AND #__{vm}_product.product_id=#__{vm}_product_category_xref.product_id AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id ";
		if(count($cat_ids) > 1){$i = 1; $q .= "AND (";
			foreach ($cat_ids as $cat_id){$q .= ($i == count($cat_ids)) ? "(#__{vm}_category.category_id='$cat_id')" : "(#__{vm}_category.category_id='$cat_id') OR \n";$i++;}
			$q .= ")  \n";
		} else { $q .= "AND #__{vm}_category.category_id='$category_id' "; }
		$q .= "AND #__{vm}_product.product_publish='Y' AND #__{vm}_product.product_special='Y' ";
		if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") $q .= " AND product_in_stock > 0 ";
		$q .= "ORDER BY RAND();";
	}
	else {
		$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product WHERE (#__{vm}_product.product_parent_id='' OR #__{vm}_product.product_parent_id='0') AND vendor_id='".$_SESSION['ps_vendor_id']."' AND #__{vm}_product.product_publish='Y' AND #__{vm}_product.product_special='Y' ";
		if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") $q .= " AND product_in_stock > 0 ";
		$q .= "ORDER BY RAND();";
	}
	
}elseif($select_type == 2){

	$q  = "SELECT p.product_id, p.product_sales as sales, p.product_parent_id, p.product_name, c.category_id, c.category_flypage FROM #__{vm}_product p, #__{vm}_product_category_xref pc, #__{vm}_category c WHERE p.product_publish='Y' AND pc.product_id = p.product_id AND pc.category_id = c.category_id AND p.product_sales > 0 GROUP BY p.product_id ORDER BY sales DESC, p.product_name;"; 
	
}elseif($select_type == 3){

	if ( $categories ) {
		$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE product_parent_id='' AND #__{vm}_product.product_id=#__{vm}_product_category_xref.product_id AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id AND #__{vm}_category.category_id='$categories' AND #__{vm}_product.product_publish='Y' ";
		if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") $q .= " AND product_in_stock > 0 ";
		$q .= "ORDER BY RAND(), product_id";
	}
	else {
		$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product WHERE product_parent_id='' AND vendor_id='".$_SESSION['ps_vendor_id']."' AND #__{vm}_product.product_publish='Y' ";
		if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") $q .= " AND product_in_stock > 0 ";
		$q .= "ORDER BY RAND(), product_id";
	}
	
}elseif($select_type == 4){

	$q  = "SELECT DISTINCT product_sku FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE product_parent_id='' AND #__{vm}_product.product_id=#__{vm}_product_category_xref.product_id AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id ";
	if( !empty( $categories ) ) $q .= "AND #__{vm}_category.category_id='$categories' ";
	if( CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1") $q .= " AND product_in_stock > 0 ";
	$q .= "AND #__{vm}_product.product_publish='Y' ORDER BY #__{vm}_product.product_id DESC;";
}

$db->query($q);

$block_width = floor( ( $module_width - ( $space * ( $visible_amount - 1 ) ) )  / $visible_amount );

if( $db->num_rows() > 0 ) {
	$products_amount = 0;
	($max_amount > $db->num_rows()) ? $products_amount = $db->num_rows() : $products_amount = $max_amount;
	
	echo '<div class="gk_vm_scroller_container_1" style="width:'.$module_width.'px">';
	echo '<div class="gk_vm_scroller_container_2" style="width: '.$module_width.'px;overflow: hidden;">';
	echo '<div class="gk_vm_scroller_container_3" style="width: '.(($products_amount*$block_width)+($space*($visible_amount-2))).'px;">';
	
	$i = 0;
	while($db->next_record() && $i < $products_amount){
	$i++;
	$styleBlock = 'height:'.$block_height.'px;width:'.$block_width.'px;';
	
	?>
		<div class="gk_vm_product_block" style="<?php echo $styleBlock; ?>">
			<div>
				<div>
					<div>
						<?php $ps_product->show_snapshot($db->f("product_sku"), $show_price, $show_cart); ?>
					</div>
				</div>
			</div>
		</div>
	<?php
	}
	
	echo '</div>';
	echo '</div>';
echo '<div id="gk_vm_pagin"><div class="gk_vm_scroller_left"></div><div class="gk_vm_scroller_right"></div></div>';
	echo '</div>';
	
	

	// scripts
	if($useMoo == 1) echo '<script type="text/javascript" src="modules/mod_gk_vm_product_scroll/scripts/mootools.js"></script>';
	if($useScript == 1) echo '<script type="text/javascript" src="modules/mod_gk_vm_product_scroll/scripts/engine.js"></script>';
	echo '<div style="clear:both;"></div>';
}
else{
	echo 'No products to show...';
}

?>
